<template>
    <ion-row>
        <ion-list class='app-mob-portlet <#if appde??>${appde.getCodeName()?lower_case}-${ctrl.name}</#if> <#if ctrl.getPSSysCss()??><#assign singleCss = ctrl.getPSSysCss()> ${singleCss.getCssName()}</#if>'>
            <#if ctrl.isShowTitleBar()>
            <ion-list-header v-if="editTitle"  class='app-mob-portlet__header'>
                <ion-input v-if="isEditTitle" :value="editTitle" @ionChange="titleChange"></ion-input>
                <span v-if="!isEditTitle"><span v-if="customizeTitle">{{customizeTitle}}</span><span v-else>{{$t('app.portlets.${ctrl.getCodeName()?lower_case}.caption')}}</span></span>
                <div v-if="actionBarModelData && actionBarModelData.length> 0" class="portlet__header_right">
                    <ion-icon v-if="!isEditTitle" name="ellipsis-horizontal-outline" @click="open"></ion-icon>
                </div>
            </ion-list-header>
            <div class="edit_title_btn" :style="edit_title_btn"><ion-button @click="onConfirmClick(false)">取消</ion-button><ion-button @click="onConfirmClick(true)">确认</ion-button></div>
            </#if><#t> 
            <#if ctrl.getPortletType?? && ctrl.getPortletType()??>
                <#if ctrl.getPortletType() == 'VIEW' && ctrl.getPortletPSAppView?? && ctrl.getPortletPSAppView()??><#t>
                <#--  视图  -->
                <#assign refview = ctrl.getPortletPSAppView()><#t>
            <${srffilepath2(refview.getCodeName())} :_context="JSON.stringify(context)" :isChildView="true" :isPortalView="true" :_viewparams="JSON.stringify(viewparams)" viewDefaultUsage="includedView" ></${srffilepath2(refview.getCodeName())}>
                <#elseif ctrl.getPortletType() == 'ACTIONBAR'>
                <#--  操作栏  -->
                <app-actionbar :items="actionBarModelData" @itemClick="handleItemClick"></app-actionbar>
                <#elseif  ctrl.getPortletType() == 'HTML'>
                <#--  网页  -->
                <iframe src="<#if ctrl.getPageUrl()??>${ctrl.getPageUrl()}</#if>" style="height: <#if ctrl.getHeight() gt 0>${ctrl.getHeight()?c}<#else>400</#if>px;width: 100%;border-width: 1px;"></iframe>
                <#elseif  ctrl.getPortletType() == 'CUSTOM'>
                <#--  自定义  -->
                    <#if ctrl.render??>
                    ${ctrl.render.code}
                    <#else>
                    <div>无扩展插件</div>
                    </#if>
                <#elseif  ctrl.getPortletType() == 'RAWITEM'>
                    <#if ctrl.getContentType() == 'HTML'>
                    <div><#if ctrl.getHtmlContent?? && ctrl.getHtmlContent()??>${ctrl.getHtmlContent()}</#if></div>
                    <#elseif ctrl.getContentType() == 'RAW'>
                    <div><#if ctrl.getRawContent?? && ctrl.getRawContent()??>${ctrl.getRawContent()}</#if></div>
                    <#elseif ctrl.getContentType() == 'IMAGE'>
                    <img src='<#if ctrl.getPSSysImage?? && ctrl.getPSSysImage()??>${ctrl.getPSSysImage().getImagePath()}</#if>'></img>
                    <#else>
                    <div>无法识别该直接内容</div>
                    </#if>
                <#elseif ctrl.getContentPSControl()??>
                <#--  图表，列表，菜单  -->
                ${P.getCtrlCode(ctrl.getContentPSControl(), 'CONTROL.html').code}
                <#else>
                <div>${ctrl.name}类型${ctrl.getPortletType()}不提供内容输出</div>
                </#if>
            </#if>
        </ion-list>
        <van-action-sheet v-model="selectStatus" get-container="#app" :actions="actionBarModelData" cancel-text="取消" close-on-click-action @select="actionBarClick" @cancel="onCancel" />
    </ion-row>
</template>